/**
 * Ίp
 */
class DiagonalSudoku : public Sudoku {
public:
	DiagonalSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval);
	~DiagonalSudoku(){}
	void print() const;
	// ʃf[^̂ create_clone() ͍ȂŗǂB
};

DiagonalSudoku::DiagonalSudoku( int rows, int cols, int mini_block_rows, int mini_block_cols, int maxval) : Sudoku( rows, cols, maxval)
{
	activate_row_blocks();
	activate_col_blocks();
	activate_diagonal_blocks();
	activate_mini_blocks( mini_block_rows, mini_block_cols);
	calc_box_blocks();
}

/**
 */
void DiagonalSudoku::print() const
{
	//--------------------------------------------------------------------
	// ̋`o͂ƂɌhǂ邽߂ɐݒ肵ĂB
	// +------+------+------+ <= ̕
	// |PEE|VEE|UEE|
	// |EQE|EEE|ETE|
	// |EER|EEX|EEE|
	// +------+------+------+ <= ̕
	// |VEE|SEE|EEW|
	// |EEE|ETE|EQE|
	// |EEE|EEU|PEE|
	// +------+------+------+
	// |SEQ|PEE|VEE|
	// |EEE|EEV|EWE|
	// |EEE|EQE|EEX|
	// +------+------+------+
	//--------------------------------------------------------------------
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			if( col % m_cols_mini_block == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX1011121314151617181920212223242526272829303132333435363738394041424344454647484950";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row%m_rows_mini_block == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col%m_cols_mini_block == 0) ps( "|");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}
