enum OneDiff {
	OD_UNKNOWN    = 0,						// 
	OD_DIFF1      = 1,						// ׂBoxƂ͈Ⴂ̐l
	OD_DIFF2      = 2,						// ׂBoxƂ2ȏقȂ鐔l
	OD_DOUBLE     = 3,						// ׂBoxƂ2{Ⴂ̐l
	OD_NOTDIFF1DBL= 4,						// ׂBoxƂ1Ⴂł{ႢłȂ
};

/**
 * Blockɏ鍷1mBoxB
 * aabac ̂悤ȏꍇɍ쐬B
 * BlockɊ܂܂Ηǂ̂ŁCɕłƂ͌ȂB
 * aab
 *  @=
 *  @c
 * Ƃ悤ȏꍇB
 * AقȂBlock̏ꍇȉ̂悤ȃp^[͉\ɂȂ̂ŁCΏۊOƂB
 * 1a2
 *  @=
 *    1
 * 3ABoxǂBlockɓĂ邩͏dvł͂Ȃ(Ă̏͂ɂ͓Ȃ)B
 */
struct BoxAbc {
	int           m_row_a;
	int           m_col_a;
	int           m_row_b;
	int           m_col_b;
	int           m_row_c;
	int           m_col_c;
};

/**
 * ႢƁB
 * BoxԂ̎wŗׂBoxƈႢC2ȏ̈Ⴂw肷B
 * 1ႢE{ႢƂ݂̂Ȃ̂łgݍށB
 */
class OneDiffSudoku : public Sudoku {
public:
	OneDiffSudoku( int rows, int cols, int rows_mini_block, int cols_mini_block, int maxval);
	//OneDiffSudoku( int rows, int cols, int maxval); ͖肪o܂ŕ
	virtual ~OneDiffSudoku(){}
	virtual Sudoku* create_clone( const Sudoku* sudoku); // @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
	virtual YesNo init_end();	// ݒ肵Box̒lgāČl̍i荞݂BBlockm̏dȂvZB
	YesNo set_row_diff( int row, int col, OneDiff od); // sԂ̋Lw肷
	YesNo set_col_diff( int row, int col, OneDiff od); // Ԃ̋Lw肷
	YesNo solve( YesNo yn_force);
	void solve_user();
	void print() const;

protected:
	virtual void decided( int row, int col, BoxVal boxval);	// l肵ƂɏʃNXĂяoB
	void box_must_diff1( int row, int col, BoxVal boxval);
	void box_must_diff2( int row, int col, BoxVal boxval);
	void box_must_double(int row, int col, BoxVal boxval);
	void box_must_notdiff1dbl(int row, int col, BoxVal boxval);
	void must_diff1( int row1, int col1, int row2, int col2);
	void must_diff2( int row1, int col1, int row2, int col2);
	void must_double(int row1, int col1, int row2, int col2);
	void must_notdiff1dbl(int row1, int col1, int row2, int col2);
	void must_diff1( int row, int col, Koho koho);
	void must_diff2( int row, int col, Koho koho);
	void must_double(int row, int col, Koho koho);
	void must_notdiff1dbl(int row, int col, Koho koho);
	void get_diff1_and_diff2( Koho koho, Koho& koho_diff1, Koho& koho_diff2);	// 傤1Ăl2ȏ㗣Ăl擾
	void get_diff1( Koho koho, Koho& koho_diff1);
	void get_double( Koho koho, Koho& koho_double);

protected:
	OneDiffSudoku(){}							// create_clone()Ŏgp

private:
	void init();
	void regist_abc_if_same_block( int row_a, int col_a, int row_b, int col_b, int row_c, int col_c); // [row_a][col_a],[row_b][col_b],[row_c][col_c]3BoxBlockɏȂo^
	YesNo is_same_block( int row_a, int col_a, int row_b, int col_b, int row_c, int col_c); // 3BoxBlockɏ邩?
	void get_using_block( int row, int col, int cnt_blocks[]); // BoxBlock߂BJEgAbvB
	void solve_user_diff2();			// 2ȏقȂBoxBlock3ԏꍇ𒲂ׂB
	void remove_diff2_if_neighbor( int iblock, BoxVal boxval1, int cnt_boxval1, BoxVal boxval2, int cnt_boxval2);
	void remove_diff2_in_abc( BoxVal boxval1, BoxVal boxval2, int row_abc[], int col_abc[]);
	void remove_abc_boxval( int row, int col, BoxVal boxval1, BoxVal boxval2);
	YesNo is_diff2_neighbor( int row1, int col1, int row2, int col2);

protected:
	// sBox̉ECBoxƂ̊֌W`B
	OneDiff      m_right[ROWS][COLS]; // EBoxƂ̊Ԃ̋L
	OneDiff      m_bottom[ROWS][COLS];	// BoxƂ̊Ԃ̋L
	// [row][col]̊֌W𒲂ׂɂ́C
	// BoxƂ̊Ԃ̊֌W𒲂ׂɂ́Cm_bottom[row-1][col]
	// BoxƂ̊Ԃ̊֌W𒲂ׂɂ́Cm_right[row][col-1]

	BoxAbc        m_abc[ROWS*COLS];	// Blockɏ鍷13ABox
	int           m_num_abc;
	YesNo         m_yn_normal;		// MINI BLOCKLǂ?
};

OneDiffSudoku::OneDiffSudoku( int rows, int cols, int rows_mini_block, int cols_mini_block, int maxval) : Sudoku( rows, cols, maxval)
{
	m_yn_normal   = YES;
	m_rows_mini_block = rows_mini_block;
	m_cols_mini_block = cols_mini_block;
	m_num_abc     = 0;
	init();
}

#if 0														// MINI BlockoȂ^Cv
OneDiffSudoku::OneDiffSudoku( int rows, int cols, int maxval) : Sudoku( rows, cols, maxval)
{
	ps( "OneDiffSudoku()\n");
	m_yn_normal   = NO;
	m_rows_mini_block = 0;
	m_cols_mini_block = 0;
	init();
	ps( "end OneDiffSudoku()\n");
}
#endif

/**
 * @ŃRs[쐬邽߂Ɏgp,hNXœƎf[^ꍇ͕K쐬ĂB
 */
Sudoku* OneDiffSudoku::create_clone( const Sudoku* src0)
{
	if( src0 == NULL) {
		OneDiffSudoku* sudoku = new OneDiffSudoku();
		return    sudoku->create_clone( this);
	}
	const OneDiffSudoku* src = (const OneDiffSudoku*)src0;
	memcpy( m_right, src->m_right, sizeof(m_right));
	memcpy( m_bottom, src->m_bottom, sizeof(m_bottom));
	memcpy( m_abc, src->m_abc, sizeof(m_abc));
	m_num_abc     = src->m_num_abc;
	m_yn_normal   = src->m_yn_normal;
	return    Sudoku::create_clone( src0);
}

/**
 */
YesNo OneDiffSudoku::init_end()
{
	YesNo         yn = Sudoku::init_end();
	if( yn == NO) return    NO;
	// Block̒3A`FbNB
	// 3AƂ aabac ̂悤ɂȂĂꍇB
	// sC񂾂ł͖̂ŁCӂB
	// 􉽊wivJ[ivŌ`󂪈łȂꍇΏł悤ɍ쐬ĂB
	// aׂ͗BoxƂ̊֌WĂ̂ŁCדmŖΈӖȂB
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			if( m_right[row][col] == OD_DIFF1) { // aab 
				if( col+1 < m_cols-1 && m_right[row][col+1] == OD_DIFF1) { // E
					regist_abc_if_same_block( row, col, row, col+1, row, col+2);
				}
				if( row-1 >= 0 && m_bottom[row-1][col+1] == OD_DIFF1) {	// 
					regist_abc_if_same_block( row, col, row, col+1, row-1, col+1);
				}
				if( row+1 < m_rows && m_bottom[row][col+1] == OD_DIFF1) {	// 
					regist_abc_if_same_block( row, col, row, col+1, row+1, col+1);
				}
			}
			if( m_bottom[row][col] == OD_DIFF1) {	// c̊֌W
				// a
				// =
				// b B
				if( col-1 >= 0 && m_right[row+1][col-1] == OD_DIFF1) { // b̍
					regist_abc_if_same_block( row, col, row+1, col, row+1, col-1);
				}
				if( col+1 < m_cols-1 && m_right[row+1][col] == OD_DIFF1) { // b̉E
					regist_abc_if_same_block( row, col, row+1, col, row+1, col+1);
				}
				if( row+1 < m_rows-1 && m_bottom[row+1][col] == OD_DIFF1) {// b̉
					regist_abc_if_same_block( row, col, row+1, col, row+2, col);
				}
			}
		}
	}
	return    yn;
}

/**
 * 3BoxBlockɓĂ3ABoxƂēo^B
 */
void OneDiffSudoku::regist_abc_if_same_block( int row_a, int col_a, int row_b, int col_b, int row_c, int col_c)
{
	if( is_same_block( row_a, col_a, row_b, col_b, row_c, col_c)) {
		m_abc[m_num_abc].m_row_a    = row_a;
		m_abc[m_num_abc].m_col_a    = col_a;
		m_abc[m_num_abc].m_row_b    = row_b;
		m_abc[m_num_abc].m_col_b    = col_b;
		m_abc[m_num_abc].m_row_c    = row_c;
		m_abc[m_num_abc].m_col_c    = col_c;

		// ^񒆂b̍ŏlƍől͌l폜łB
		remove_koho( row_b, col_b, 1);
		remove_koho( row_b, col_b, m_maxval);
		m_num_abc++;
	}
}

/**
 * 3BoxSēBlockɓĂ邩?
 */
YesNo OneDiffSudoku::is_same_block( int row_a, int col_a, int row_b, int col_b, int row_c, int col_c)
{
	int           cnt_blocks[BLOCKS+1]={0};
	// ėpIɍ쐬B
	get_using_block( row_a, col_a, cnt_blocks);
	get_using_block( row_b, col_b, cnt_blocks);
	get_using_block( row_c, col_c, cnt_blocks);
	for( int i=0; i< m_num_blocks; i++) {
		if( cnt_blocks[i] == 3) {				// 3BoxSĂBlockɓĂB
			return    YES;						// ǂꂩłBlockOK
		}
	}
	return    NO;									// BoxBlockoo,2͓mȂC3łȂ΃_B
}

void OneDiffSudoku::get_using_block( int row, int col, int cnt_blocks[])
{
	Box&          box = m_box[row][col];
	int           num_blocks = box.m_num_blocks;
	for( int i=0; i< num_blocks; i++) {
		cnt_blocks[box.m_block_id[i]]++;
	}
}

void OneDiffSudoku::init()
{
	memset( m_right, 0, sizeof(m_right));
	memset( m_bottom, 0, sizeof(m_right));
	activate_row_blocks();
	activate_col_blocks();
	if( m_yn_normal) {
		activate_mini_blocks( m_rows_mini_block, m_cols_mini_block);
	}
	calc_box_blocks();
}

/**
 * Box̌lm肵B
 * ㉺E̋L𒲂ׂāČׂli荞ށB
 */
void OneDiffSudoku::decided( int row, int col, BoxVal boxval)
{
	ps( "decided(%d,%d,%d)\n", row, col, boxval);
	if( col >= m_cols-1) {}
	else if( m_right[row][col]    == OD_DIFF1      ) box_must_diff1(       row,   col+1, boxval); // E
	else if( m_right[row][col]    == OD_DIFF2      ) box_must_diff2(       row,   col+1, boxval);
	else if( m_right[row][col]    == OD_DOUBLE     ) box_must_double(      row,   col+1, boxval);
	else if( m_right[row][col]    == OD_NOTDIFF1DBL) box_must_notdiff1dbl( row,   col+1, boxval);
	if( row >= m_rows-1) {}
	else if( m_bottom[row][col]   == OD_DIFF1      ) box_must_diff1(       row+1, col,   boxval);	// 
	else if( m_bottom[row][col]   == OD_DIFF2      ) box_must_diff2(       row+1, col,   boxval);
	else if( m_bottom[row][col]   == OD_DOUBLE     ) box_must_double(      row+1, col,   boxval);
	else if( m_bottom[row][col]   == OD_NOTDIFF1DBL) box_must_notdiff1dbl( row+1, col,   boxval);
	if( row == 0) {}
	else if( m_bottom[row-1][col] == OD_DIFF1      ) box_must_diff1(       row-1, col,   boxval); // 
	else if( m_bottom[row-1][col] == OD_DIFF2      ) box_must_diff2(       row-1, col,   boxval);
	else if( m_bottom[row-1][col] == OD_DOUBLE     ) box_must_double(      row-1, col,   boxval);
	else if( m_bottom[row-1][col] == OD_NOTDIFF1DBL) box_must_notdiff1dbl( row-1, col,   boxval);
	if( col == 0) {}
	else if( m_right[row][col-1]  == OD_DIFF1      ) box_must_diff1(       row,   col-1, boxval);	// 
	else if( m_right[row][col-1]  == OD_DIFF2      ) box_must_diff2(       row,   col-1, boxval);
	else if( m_right[row][col-1]  == OD_DOUBLE     ) box_must_double(      row,   col-1, boxval);
	else if( m_right[row][col-1]  == OD_NOTDIFF1DBL) box_must_notdiff1dbl( row,   col-1, boxval);
}

/**
 * [row][col]boxval_diff11Ⴂ̌lɂȂB
 * ƂƂ2ȏႤl͍폜B
 */
void OneDiffSudoku::box_must_diff1( int row, int col, BoxVal boxval_diff1)
{
	Box&          box = rowcol2box( row, col);
	Koho          koho = box.m_koho;
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( abs( (int)boxval-(int)boxval_diff1) >= 2 && (koho&kohobit[boxval])) {
			//ps( "remove_koho(%d,%d,%d)box_must_diff1\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]boxval_diff22ȏႤlɂȂB
 * ƂƂ́C}1Ȃl폜B
 */
void OneDiffSudoku::box_must_diff2( int row, int col, BoxVal boxval_diff2)
{
	Box&          box = rowcol2box( row, col);
	Koho          koho = box.m_koho;
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( abs( (int)boxval-(int)boxval_diff2) <= 1 && (koho&kohobit[boxval])) {
			//ps( "remove_koho(%d,%d,%d)box_must_diff2\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]boxval_double2{ႤlɂȂB
 */
void OneDiffSudoku::box_must_double( int row, int col, BoxVal boxval_double)
{
	Box&          box = rowcol2box( row, col);
	Koho          koho = box.m_koho;
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( !(koho & kohobit[boxval])) continue;
		if( boxval*2 == boxval_double ||
				boxval   == boxval_double*2) {
			// 傤2{Ⴄ
		}
		else {
			//ps( "remove_koho(%d,%d,%d)box_must_double\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]boxval_notdiff1dbl1Ⴂł2{ႢłȂlɂȂB
 */
void OneDiffSudoku::box_must_notdiff1dbl( int row, int col, BoxVal boxval_notdiff1dbl)
{
	Box&          box = rowcol2box( row, col);
	Koho          koho = box.m_koho;
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( !(koho & kohobit[boxval])) continue;
		if( boxval*2 == boxval_notdiff1dbl ||
				boxval   == boxval_notdiff1dbl*2) {
			// 傤2{Ⴄ
			Sudoku::remove_koho( row, col, boxval);
		}
		else if( abs( (int)boxval-(int)boxval_notdiff1dbl) <= 1) {
			Sudoku::remove_koho( row, col, boxval);	// Ⴂ
		}
		else {
		}
	}
}

/**
 * Ԃ̋Lw肷
 */
YesNo OneDiffSudoku::set_col_diff( int row, int col, OneDiff hl)
{
	if( !exist_box( row, col)) return    NO;
	m_right[row][col] = hl;
	return    YES;
}

/**
 * sԂ̋Lw肷
 */
YesNo OneDiffSudoku::set_row_diff( int row, int col, OneDiff hl)
{
	if( !exist_box( row, col)) return    NO;
	m_bottom[row][col]    = hl;
	return    YES;
}

YesNo OneDiffSudoku::solve( YesNo yn_force)
{
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			if( col >= m_cols-1) {}
			else if( m_right[row][col] == OD_DIFF1) {
				must_diff1( row, col, row, col+1); // דm̌ĺ}1
			}
			else if( m_right[row][col] == OD_DIFF2) {
				must_diff2( row, col, row, col+1); // דm̌l2ȏႤ
			}
			else if( m_right[row][col] == OD_DOUBLE) {
				must_double( row, col, row, col+1); // דm̌l͔{Ⴄ
			}
			else if( m_right[row][col] == OD_NOTDIFF1DBL) {
				must_notdiff1dbl( row, col, row, col+1); // דm̌l1Ⴂł{Ⴂł
			}
			if( row >= m_rows-1) {}
			else if( m_bottom[row][col] == OD_DIFF1) {
				must_diff1( row, col, row+1, col); // דm̌ĺ}1
			}
			else if( m_bottom[row][col] == OD_DIFF2) {
				must_diff2( row, col, row+1, col); // דm̌l2ȏႤ
			}
			else if( m_bottom[row][col] == OD_DOUBLE) {
				must_double( row, col, row+1, col); // דm̌l͔{Ⴄ
			}
			else if( m_bottom[row][col] == OD_NOTDIFF1DBL) {
				must_notdiff1dbl( row, col, row+1, col); // דm̌l1Ⴂł{Ⴂł
			}
		}
	}
	return    Sudoku::solve(yn_force);
}

/**
 */
void OneDiffSudoku::solve_user()
{
	for( int row=0; row< m_rows; row++) {
		for( int col=0; col< m_cols; col++) {
			if( col >= m_cols-1) {}
			else if( m_right[row][col] == OD_DIFF1) {
				must_diff1( row, col, row, col+1); // דm̌ĺ}1
			}
			else if( m_right[row][col] == OD_DIFF2) {
				must_diff2( row, col, row, col+1); // דm̌l2ȏႤ
			}
			else if( m_right[row][col] == OD_DOUBLE) {
				must_double( row, col, row, col+1); // דm̌l͔{Ⴄ
			}
			else if( m_right[row][col] == OD_NOTDIFF1DBL) {
				must_notdiff1dbl( row, col, row, col+1); // דm̌l1Ⴂł{Ⴂł
			}
			if( row >= m_rows-1) {}
			else if( m_bottom[row][col] == OD_DIFF1) {
				must_diff1( row, col, row+1, col); // דm̌ĺ}1
			}
			else if( m_bottom[row][col] == OD_DIFF2) {
				must_diff2( row, col, row+1, col); // דm̌l2ȏႤ
			}
			else if( m_bottom[row][col] == OD_DOUBLE) {
				must_double( row, col, row+1, col);	// דm̌l͔{Ⴄ
			}
			else if( m_bottom[row][col] == OD_NOTDIFF1DBL) {
				must_notdiff1dbl( row, col, row+1, col); // דm̌l1Ⴂł{Ⴂł
			}
		}
	}
	for( int i=0; i< m_num_abc; i++) {
		const BoxAbc&   abc = m_abc[i];
		Koho        a_diff = 0, b_diff = 0, c_diff = 0;	// č
		Koho        a = get_koho( abc.m_row_a, abc.m_col_a); if( a == 0) a = kohobit[get_boxval(abc.m_row_a,abc.m_col_a)];
		Koho        b = get_koho( abc.m_row_b, abc.m_col_b); if( b == 0) b = kohobit[get_boxval(abc.m_row_b,abc.m_col_b)];
		Koho        c = get_koho( abc.m_row_c, abc.m_col_c); if( c == 0) c = kohobit[get_boxval(abc.m_row_c,abc.m_col_c)];
		for( BoxVal boxval=2; boxval< m_maxval; boxval++) {	// 3x31`8, <= ł͂Ȃ, m_num_boxesł͂Ȃ
			if( !(b & kohobit[boxval])) continue;
			BoxVal    b0 = boxval-1, b1 = boxval+1;
			if( (a & kohobit[b0]) && (c & kohobit[b1])) {
				a_diff  |= kohobit[b0];
				b_diff  |= kohobit[boxval];
				c_diff  |= kohobit[b1];
			}
			if( (a & kohobit[b1]) && (c & kohobit[b0])) {
				a_diff  |= kohobit[b1];
				b_diff  |= kohobit[boxval];
				c_diff  |= kohobit[b0];
			}
		}
		if( a_diff != a) replace_koho( abc.m_row_a, abc.m_col_a, a_diff);
		if( b_diff != b) replace_koho( abc.m_row_b, abc.m_col_b, b_diff);
		if( c_diff != c) replace_koho( abc.m_row_c, abc.m_col_c, c_diff);
	}
	solve_user_diff2();						// 
}

/**
 * 2ȏقȂBoxBlock3ԏꍇ𒲂ׂB
 * l23̎ɌČl폜łB
 * a|b|c  a5,6,7 b5,6,7 c5,6,7 Ȃb6͍폜łB
*/
void OneDiffSudoku::solve_user_diff2()
{
	for( int i=0; i< m_num_blocks; i++) {
		Block&      block = m_blocks[i];
		int         cnt_koho[MAXVAL+1] = {0};
		for( int j=0; j< m_num_boxes; j++) {	// Block̑SĂBox̏o񐔂肷
			int       row, col;				// dummy
			Box&      box = pos2box( block.m_box_pos[j], row, col);
			Koho      koho = box.m_koho;
			for( BoxVal boxval=1; boxval <= m_maxval; boxval++) {
				if( koho & kohobit[boxval]) cnt_koho[boxval]++;
			}
		}
		for( BoxVal boxval=1; boxval <= m_maxval; boxval++) {
			if( ( cnt_koho[boxval]   == 2 || cnt_koho[boxval]   == 3) && // A2̐̌l23
					( cnt_koho[boxval+1] == 2 || cnt_koho[boxval+1] == 3)) {
				// ̌lׂ荇ꏊɂ΍폜łB
				remove_diff2_if_neighbor( i, boxval, cnt_koho[boxval], boxval+1, cnt_koho[boxval+1]);
			}
		}
	}
}

/**
 * boxval1  boxval2 ̌lׂ荇ꏊɂΐ^񒆂̐폜łB
 * a|b|c 
 * 56|56|56 ̂悤ɂȂĂC^񒆂56͍폜łB
 * 56||56 ɂȂB
 * ŔC^񒆂̐5ɐݒ肷ƁCׂ2ȏ㗣ĂȂ΂ȂȂ̂ŁC6̓_B
 * Ɛ^񒆂܂6̒uꏊȂB
 * āC^񒆂5̓_Blɐ^񒆂6_B
 */
void OneDiffSudoku::remove_diff2_if_neighbor( int iblock, BoxVal boxval1, int cnt_boxval1, BoxVal boxval2, int cnt_boxval2)
{
	// boxval1boxval2A3BoxɓĂ邩?
	// ĂȂ^񒆂̌lboxval1boxval2폜B
	// l3łȂC2̏ꍇB
	// 2̏ꍇ̂ŁCӁB
	// BoxԂ̕ǂ ałȂCbɂȂĂ邱ƂmFȂ΂ȂȂB
	int           row_abc[6+1];
	int           col_abc[6+1];
	int           n = 0;
	int           row, col;
	Koho          koho1 = kohobit[boxval1];
	Koho          koho2 = kohobit[boxval2];
	Block&        block = m_blocks[iblock];
	for( int j=0; j< m_num_boxes; j++) {
		pos2rowcol( block.m_box_pos[j], row, col);
		if( koho1 & get_koho(row,col)) {
			row_abc[n]= row;
			col_abc[n]= col;
			n++;
		}
		else if( koho2 & get_koho(row,col)) {
			row_abc[n]= row;
			col_abc[n]= col;
			n++;
		}
		if( n >= 4) return;					// 2̌l4ӏȏɏoB3ӏȓɏoȂ΍폜łȂB
	}
	mt_assert( n >= 2);						// ȂƂ2ӏȏɏoȂΉB
	if( n != 3) return;						// solve_NxN()Ōli,ł͂ȏi荞߂ȂB
	// l̐2łCBox3ӏăp^[Bȉ̂悤ȏꍇB
	// ̏ꍇC^񒆂5폜łB
	// 5|5|
	// 6| |6
	remove_diff2_in_abc( boxval1, boxval2, row_abc, col_abc);
}

/**
 * 3ӏBoxAĂ邩?
 * ׂBoxƂ̋Éb?
 * ȏ𖞂ꍇC^񒆂̌l폜łB
 */
void OneDiffSudoku::remove_diff2_in_abc( BoxVal boxval1, BoxVal boxval2, int row_abc[], int col_abc[])
{
	YesNo yn_ab = is_diff2_neighbor( row_abc[0], col_abc[0], row_abc[1], col_abc[1]);
	YesNo yn_ac = is_diff2_neighbor( row_abc[0], col_abc[0], row_abc[2], col_abc[2]);
	YesNo yn_bc = is_diff2_neighbor( row_abc[1], col_abc[1], row_abc[2], col_abc[2]);
	if( yn_ab && yn_ac) remove_abc_boxval( row_abc[0], col_abc[0], boxval1, boxval2);
	if( yn_ab && yn_bc) remove_abc_boxval( row_abc[1], col_abc[1], boxval1, boxval2);
	if( yn_bc && yn_ac) remove_abc_boxval( row_abc[2], col_abc[2], boxval1, boxval2);
}

YesNo OneDiffSudoku::is_diff2_neighbor( int row1, int col1, int row2, int col2)
{
	if( abs(row1-row2) >= 2) return    NO;
	if( abs(col1-col2) >= 2) return    NO;
	OneDiff       od;
	if( row1-row2 == 0) {					// ׂ荇Ă
		if( col1 > col2) od = m_right[row1][col2];
		else             od = m_right[row1][col1];
		if( od == OD_DIFF2) return    YES;
		return    NO;
	}
	else if( col1-col2 == 0) {
		if( row1 > row2) od = m_bottom[row2][col1];
		else             od = m_bottom[row1][col1];
		if( od == OD_DIFF2) return    YES;
		return    NO;
	}
	return    NO;
}

/**
 * [row][col]Ɍlboxval1,boxval2Όl폜B
 */
void OneDiffSudoku::remove_abc_boxval( int row, int col, BoxVal boxval1, BoxVal boxval2)
{
	Koho          koho = get_koho( row, col);
	if( koho & kohobit[boxval1]) remove_koho( row, col, boxval1);
	if( koho & kohobit[boxval2]) remove_koho( row, col, boxval2);
}

/**
 * BoxԂ̌l̍́}1ȉB
 * [row1][col1]猩[row2][col2]
 * [row2][col2]猩[row1][col1]B
 */
void OneDiffSudoku::must_diff1( int row1, int col1, int row2, int col2)
{
	Koho          koho1 = rowcol2box( row1, col1).m_koho;
	Koho          koho2 = rowcol2box( row2, col2).m_koho;
	if( koho1 != 0) must_diff1( row2, col2, rowcol2box(row1,col1).m_koho);
	else            box_must_diff1( row2, col2, get_boxval(row1,col1));
	if( koho2 != 0) must_diff1( row1, col1, rowcol2box(row2,col2).m_koho);
	else            box_must_diff1( row1, col1, get_boxval(row2,col2));
}

/**
 * BoxԂ̌l̍2ȏB
 * [row1][col1]猩[row2][col2]
 * [row2][col2]猩[row1][col1]B
 */
void OneDiffSudoku::must_diff2( int row1, int col1, int row2, int col2)
{
	Koho          koho1 = rowcol2box( row1, col1).m_koho;
	Koho          koho2 = rowcol2box( row2, col2).m_koho;
	if( koho1 != 0) must_diff2( row2, col2, rowcol2box(row1,col1).m_koho);
	else            box_must_diff2( row2, col2, get_boxval(row1,col1));
	if( koho2 != 0) must_diff2( row1, col1, rowcol2box(row2,col2).m_koho);
	else            box_must_diff2( row1, col1, get_boxval(row2,col2));
}

/**
 * BoxԂ̌l2{ႤB
 * [row1][col1]猩[row2][col2]
 * [row2][col2]猩[row1][col1]B
 */
void OneDiffSudoku::must_double( int row1, int col1, int row2, int col2)
{
	Koho          koho1 = rowcol2box( row1, col1).m_koho;
	Koho          koho2 = rowcol2box( row2, col2).m_koho;
	if( koho1 != 0) must_double( row2, col2, rowcol2box(row1,col1).m_koho);
	else            box_must_double( row2, col2, get_boxval(row1,col1));
	if( koho2 != 0) must_double( row1, col1, rowcol2box(row2,col2).m_koho);
	else            box_must_double( row1, col1, get_boxval(row2,col2));
}

/**
 */
void OneDiffSudoku::must_notdiff1dbl( int row1, int col1, int row2, int col2)
{
	Koho          koho1 = rowcol2box( row1, col1).m_koho;
	Koho          koho2 = rowcol2box( row2, col2).m_koho;
	if( koho1 != 0) must_notdiff1dbl( row2, col2, rowcol2box(row1,col1).m_koho);
	else            box_must_notdiff1dbl( row2, col2, get_boxval(row1,col1));
	if( koho2 != 0) must_notdiff1dbl( row1, col1, rowcol2box(row2,col2).m_koho);
	else            box_must_notdiff1dbl( row1, col1, get_boxval(row2,col2));
}

/**
 * [row][col]kohoŎw肷lƂ̍}1ȉ
 */
void OneDiffSudoku::must_diff1( int row, int col, Koho koho)
{
	//mt_assert( koho != 0);				// dlŃR[h쐬̂
	Koho          koho_diff1, koho_diff2;
	get_diff1_and_diff2( koho, koho_diff1, koho_diff2);
	Koho          koho_remove = get_koho( row, col) & ( ~koho_diff1);	// 2ȏ㗣Ă폜C1ĂȂcB
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( koho_remove & kohobit[boxval]) {
			//ps( "remove_koho(%d,%d,%d)must_diff1\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]kohoŎw肷lƂ̍2ȏ
 */
void OneDiffSudoku::must_diff2( int row, int col, Koho koho)
{
	Koho          koho_diff1, koho_diff2;
	get_diff1_and_diff2( koho, koho_diff1, koho_diff2);
	Koho          koho_remove = get_koho( row, col) & ( ~koho_diff2 ); // 2ȏ㗣Ăc
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( koho_remove & kohobit[boxval]) {
			//ps( "remove_koho(%d,%d,%d)must_diff2\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]kohoŎw肷l2{Ⴄ
 */
void OneDiffSudoku::must_double( int row, int col, Koho koho)
{
	Koho          koho_double;
	get_double( koho, koho_double);
	Koho          koho_remove = get_koho( row, col) & ( ~koho_double );	
	for( BoxVal boxval=1; boxval<= m_maxval; boxval++) {
		if( koho_remove & kohobit[boxval]) {
			//ps( "remove_koho(%d,%d,%d)must_double\n", row, col, boxval);
			Sudoku::remove_koho( row, col, boxval);
		}
	}
}

/**
 * [row][col]kohoŎw肷lƈႢł{ႢłB
 */
void OneDiffSudoku::must_notdiff1dbl( int row, int col, Koho koho)
{
	// J͂ɂ͌ʂȂ̂ŉȂB
	// Ⴆ΁Cl347łƂB
	// ƁCǂ̐lĂ1Ⴂł͂ȂƂɂȂB
}

/**
 * kohoŎw肳SĂ̌lC
 * 傤1Ăl
 * 2ȏ㗣Ăl擾B
 */
void OneDiffSudoku::get_diff1_and_diff2( Koho koho, Koho& koho_diff1, Koho& koho_diff2)
{
	int           maxval = get_maxval();
	koho_diff1    = 0;
	koho_diff2    = get_all_koho();
	Koho          koho2;
	for( BoxVal boxval=1; boxval<= maxval; boxval++) {
		if( koho & kohobit[boxval]) {
			koho_diff1 |= kohobit[boxval-1];
			koho2     = kohobit[boxval-1];
			// koho_diff1 |= kohobit[boxval]͓lɂȂ̂őΏۊOɂB
			koho2     |= kohobit[boxval];
			if( boxval < maxval) {
				koho_diff1 |= kohobit[boxval+1];
				koho2   |= kohobit[boxval+1]; // ŌOverȂ悤
			}
			koho_diff2&= koho2;
		}
	}
	koho_diff2    = ~koho_diff2;
}

/**
 * kohoŎw肳SĂ̌l1ĂlTB
 */
void OneDiffSudoku::get_diff1( Koho koho, Koho& koho_diff1)
{
	int           maxval = get_maxval();
	koho_diff1   = 0;
	for( BoxVal boxval=1; boxval<= maxval; boxval++) {
		if( koho & kohobit[boxval]) {
			koho_diff1 |= kohobit[boxval-1];
			if( boxval < maxval) {
				koho_diff1 |= kohobit[boxval+1];
			}
		}
	}
	ps( "get_diff1(%d,%d)\n", koho, koho_diff1);
}

/**
 * kohoŎw肳SĂ̌l2{ĂlTB
 */
void OneDiffSudoku::get_double( Koho koho, Koho& koho_double)
{
	int           maxval = get_maxval();
	koho_double   = 0;
	for( BoxVal boxval=1; boxval<= maxval; boxval++) {
		if( koho & kohobit[boxval]) {
			if( boxval*2 <= maxval) {	// 2{Ă
				koho_double |= kohobit[boxval*2];
			}
			if( (boxval&1) == 0) {			// 
				koho_double |= kohobit[boxval/2];	// 傤ǔCƂƂ͔̌l猩2{Ă
			}
		}
	}
	ps( "get_double(%d,%d)\n", koho, koho_double);
}

/**
 * m[}Ƃ݂̌̏ԂR\[ɏo͂B
 */
void OneDiffSudoku::print() const
{
	ps( "print()\n");
	char          m_rowline[1024];
	{
		int i = 0;
		for( int col=0; col< m_cols; col++) {
			//if( col == 0 || (col % m_cols_mini_block == 0)) m_rowline[i++] = '+';
			if( col == 0) m_rowline[i++] = '+';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
			m_rowline[i++] = '-'; m_rowline[i++] = '-';
		}
		m_rowline[i++]= '+';
		m_rowline[i]= NIL;
	}

	cstring ss = "EPQRSTUVWX1011121314151617181920212223242526272829303132333435363738394041424344454647484950";
	int           row, col;
	int           n=0;
	for( row=0; row< m_rows; row++) {
		if( row == 0) ps( "%s\n", m_rowline);
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "|");
			ps( "%-.2s", ss+get_boxval(row,col)*2);
			if( m_right[row][col] == OD_DIFF1) ps( "a");
			else if( m_right[row][col] == OD_DIFF2) ps( "");
			else if( m_right[row][col] == OD_DOUBLE) ps( "");
			else if( m_right[row][col] == OD_NOTDIFF1DBL) ps( "");
			else ps( "@");
			if( get_boxval(row,col) != BoxValNone) n++;
		}
		ps( "|\n");
		for( col=0; col< m_cols; col++) {
			if( col == 0) ps( "|");
			if( m_bottom[row][col] == OD_DIFF1) ps( "@");
			else if( m_bottom[row][col] == OD_DIFF2) ps( "@");
			else if( m_bottom[row][col] == OD_DOUBLE) ps( "@");
			else if( m_bottom[row][col] == OD_NOTDIFF1DBL) ps( "@");
			else ps( "@@");
		}
		ps( "|\n");
	}
	ps( "%s\n", m_rowline);
	ps( "萔 : %d \n", n);
}

